#ifndef SYNTAX_H
#define SYNTAX_H

#include <vector>
#include <string>

class Node {
public:
  virtual void display() = 0;
};

class IdNode : public Node {
private:
  std::string *id;
public:
  IdNode(std::string*);
  virtual void display();
};

class NumNode : public Node {
private:
  float num;
public:
  NumNode(float);
  virtual void display();
};

class StringNode : public Node {
private:
  std::string* stringVal;
public:
  StringNode(std::string*);
  virtual void display();
};

class OpNode : public Node {
private:
  int op;
  Node *first;
  Node *second;
public:
  OpNode(int, Node*, Node*);
  virtual void display();
};

class NodeList : public std::vector<Node*>{};

void print_expression_list(NodeList *);

#endif /* SYNTAX_H */
